<template>
  <v-dialog width="500" v-model="appDialogs[dialogName].show">
    <v-card>
      <v-card-title class="headline mb-4">{{ title }}</v-card-title>

      <v-card-text>
        <slot name="dialog-content" />
      </v-card-text>

      <v-divider></v-divider>

      <v-card-actions>
        <v-spacer></v-spacer>
        <div class="d-flex justify-center align-center">
            <slot name="dialog-actions" />
            <v-btn v-if="cancellable" color="secondary" text @click="handleCancelClick">Cancel</v-btn>
        </div>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script lang="ts">
import { defineComponent, PropType } from "@vue/composition-api";
import { useDialogs } from "@/compositions";
import { DialogConfig, DialogName } from "@/ts";

export default defineComponent({
  name: "AppDialog",
  props: {
      dialogName: {
          type: String as PropType<DialogName>,
          required: true
      },
      title: {
        type: String
      },
      cancellable: {
          type: Boolean,
          default: false
      }
  },
  setup(props) {
    const appDialogs = useDialogs().getDialogs();

    const handleCancelClick = () => {
        const dialogName = props.dialogName as DialogName;
        const dialog = appDialogs.value[dialogName] as DialogConfig;
        dialog.show = false;
    }
    return { appDialogs, handleCancelClick }
  }
});
</script>

<style scoped>

</style>